 
// vericasa, mostracan, calcand

func vericasa(digitado)   // verifica se o numero numa casa ja esta na linha, na coluna ou no grupo
loca coinc := {}
loca i := 0
loca qelem := 0
loca xgrupo := 0
loca xcasa := 0
loca xlin := 0
loca xcol := 0
loca onde := 0
loca val_ret := .f.

qelem = ascan(casas,{|e| e[8] = xultlin .and. e[9] = xultcol})
xgrupo = casas[qelem][6]
xcasa  = casas[qelem][7]
xlin   = casas[qelem][4]
xcol   = casas[qelem][5]

for i = 1 to 9 // procura nas colunas de uma linha
   if i <> xcol
      onde = ascan(casas,{|e| e[4] = xlin .and. e[5] = i})
      if casas[onde][2] == digitado
         aadd(coinc,{casas[onde][8],casas[onde][9]})
      endi
   endi
next

for i = 1 to 9 // procura nas linhas de uma coluna
   if i <> xlin
      onde = ascan(casas,{|e| e[5] = xcol .and. e[4] = i})
      if casas[onde][2] == digitado
         aadd(coinc,{casas[onde][8],casas[onde][9]})
      endi
   endi
next

for i = 1 to 9
   if i <> xcasa
      onde = ascan(casas,{|e| e[6] = xgrupo .and. e[7] = i})
      if casas[onde][2] == digitado
         aadd(coinc,{casas[onde][8],casas[onde][9]})
      endi
   endi
next

if len(coinc) > 0
   for i = 1 to len(coinc)
      xlin = coinc[i][1]
      xcol = coinc[i][2]
      onde = ascan(casas,{|e| e[8] = xlin .and. e[9] = xcol})
      if len(alltrim(casas[onde][2])) = 1
         casas[onde][2] = 'o' + casas[onde][2]
      endi
   next
   casas[qelem][2] = 'o' + casas[qelem][2]
   val_ret = .t.
endi
retu val_ret

func mostracan()
loca i := 0
loca msg := ''
loca qelem := 0
loca temp1 := ''
loca temp2 := ''
loca letras := 'ABCDEFGHI'
loca tammsg := 0
loca telant := ''
loca corant := ''
loca curant := 0
loca cd := 0

qelem = ascan(casas,{|e| e[8] = xultlin .and. e[9] = xultcol})

if casas[qelem][1] = .f.
   temp1 = alltrim(casas[qelem][3])
   for i = 1 to len (temp1)
      temp2 = temp2 + subs(temp1,i,1)+','
   next
   if subs(temp2,len(temp2),1) = ','
      temp2 = subs(temp2,1,len(temp2)-1)
   endi
   msg = diga[27]+' '+subs(letras,casas[qelem][5],1)+str(casas[qelem][6],1,0)+': '+temp2
   tammsg = len(msg)
   cd = 41 + tammsg + 1
   telant = savescreen(10,41,12,cd)
   corant = setcolor('+w/r')
   curant = setcursor(0)
   @ 10,41,12,cd box chr(218)+chr(196)+chr(191)+chr(179)+chr(217)+chr(196)+chr(192)+chr(179)
   @ 11,42 say msg
   inkey(0)
   setcolor(corant)
   restscreen(10,41,12,cd,telant)
   setcursor(curant)
endi
retu

func calcand() // calcula candidatos eliminando valores dados e guesses por linha, coluna e grupo, e atualiza casas{}
loca l := 0
loca c := 0
loca g := 0
loca cg := 0
loca qelem := 0
loca temp1 := ''
loca temp2 := ''

for l = 1 to 9 // linhas
   temp1 = ''
   for c = 1 to 9
      qelem = ascan(casas,{|e| e[4] = l .and. e[5] = c})
      if len(alltrim(casas[qelem][2])) = 1
         temp1 = temp1 + alltrim(casas[qelem][2])
      endi
   next
   for c = 1 to 9
      qelem = ascan(casas,{|e| e[4] = l .and. e[5] = c})
      if casas[qelem][1] = .f.
         temp2 = tira(temp1,casas[qelem][3])
         casas[qelem][3] = temp2
         temp2 = ''
      endi
   next
next

for c = 1 to 9 // colunas
   temp1 = ''
   for l = 1 to 9
      qelem = ascan(casas,{|e| e[4] = l .and. e[5] = c})
      if len(alltrim(casas[qelem][2])) = 1
         temp1 = temp1 + (alltrim(casas[qelem][2]))
      endi
   next
   for l = 1 to 9
      qelem = ascan(casas,{|e| e[4] = l .and. e[5] = c})
      if casas[qelem][1] = .f.
         temp2 = tira(temp1,casas[qelem][3])
         casas[qelem][3] = temp2
         temp2 = ''
      endi
   next
next

for g = 1 to 9 // grupos
   temp1 = ''
   for cg = 1 to 9
      qelem = ascan(casas,{|e| e[6] = g .and. e[7] = cg})
      if len(alltrim(casas[qelem][2])) = 1
         temp1 = temp1 + (alltrim(casas[qelem][2]))
      endi
   next
   for cg = 1 to 9
      qelem = ascan(casas,{|e| e[6] = g .and. e[7] = cg})
      if casas[qelem][1] = .f.
         temp2 = tira(temp1,casas[qelem][3])
         casas[qelem][3] = temp2
         temp2 = ''
      endi
   next
next
retu

func tira(parte,todo) // ex. tira('71','231457') = '2345' / tira('123','456') = '456' / tira('123','1') = '1'
loca i := 0           //     tira('2',123456789) = '13456789)
loca pt := ''
loca val_ret := todo

for i = 1 to len(todo)
   if at(subs(todo,i,1),parte) = 0
      pt = pt + subs(todo,i,1)
   endi
next
if len(pt) > 0
   val_ret = pt
endi
retu val_ret
